/*
 * Automatically generated by asn1_compiler.  Do not edit
 *
 * ASN.1 parser for pkcs7
 */
#include <linux/asn1_ber_bytecode.h>
#include "pkcs7-asn1.h"

enum pkcs7_actions {
	ACT_pkcs7_extract_cert = 0,
	ACT_pkcs7_note_OID = 1,
	ACT_pkcs7_note_authenticated_attr = 2,
	ACT_pkcs7_note_certificate_list = 3,
	ACT_pkcs7_note_data = 4,
	ACT_pkcs7_note_digest_algo = 5,
	ACT_pkcs7_note_issuer = 6,
	ACT_pkcs7_note_pkey_algo = 7,
	ACT_pkcs7_note_serial = 8,
	ACT_pkcs7_note_set_of_authattrs = 9,
	ACT_pkcs7_note_signature = 10,
	NR__pkcs7_actions = 11
};

static const asn1_action_t pkcs7_action_table[NR__pkcs7_actions] = {
	[   0] = pkcs7_extract_cert,
	[   1] = pkcs7_note_OID,
	[   2] = pkcs7_note_authenticated_attr,
	[   3] = pkcs7_note_certificate_list,
	[   4] = pkcs7_note_data,
	[   5] = pkcs7_note_digest_algo,
	[   6] = pkcs7_note_issuer,
	[   7] = pkcs7_note_pkey_algo,
	[   8] = pkcs7_note_serial,
	[   9] = pkcs7_note_set_of_authattrs,
	[  10] = pkcs7_note_signature,
};

static const unsigned char pkcs7_machine[] = {
	// PKCS7ContentInfo
	[   0] = ASN1_OP_MATCH,
	[   1] = _tag(UNIV, CONS, SEQ),
	// ContentType
	[   2] =  ASN1_OP_MATCH_ACT,
	[   3] =  _tag(UNIV, PRIM, OID),
	[   4] =  _action(ACT_pkcs7_note_OID),
	[   5] =  ASN1_OP_MATCH_JUMP_OR_SKIP,		// content
	[   6] =  _tagn(CONT, CONS,  0),
	[   7] =  _jump_target(10),
	[   8] = ASN1_OP_END_SEQ,
	[   9] = ASN1_OP_COMPLETE,

	// SignedData
	[  10] =  ASN1_OP_MATCH,
	[  11] =  _tag(UNIV, CONS, SEQ),
	[  12] =   ASN1_OP_MATCH,		// version
	[  13] =   _tag(UNIV, PRIM, INT),
	// DigestAlgorithmIdentifiers
	[  14] =   ASN1_OP_MATCH_JUMP_OR_SKIP,		// daSet
	[  15] =   _tag(UNIV, CONS, SET),
	[  16] =   _jump_target(56),
	[  17] =   ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// daSequence
	[  18] =   _tag(UNIV, CONS, SEQ),
	[  19] =   _jump_target(62),
	[  20] =   ASN1_OP_COND_FAIL,
	[  21] =   ASN1_OP_ACT,
	[  22] =   _action(ACT_pkcs7_note_digest_algo),
	// ContentInfo
	[  23] =   ASN1_OP_MATCH,
	[  24] =   _tag(UNIV, CONS, SEQ),
	// ContentType
	[  25] =    ASN1_OP_MATCH_ACT,
	[  26] =    _tag(UNIV, PRIM, OID),
	[  27] =    _action(ACT_pkcs7_note_OID),
	[  28] =    ASN1_OP_MATCH_JUMP_OR_SKIP,		// content
	[  29] =    _tagn(CONT, CONS,  0),
	[  30] =    _jump_target(68),
	[  31] =   ASN1_OP_END_SEQ,
	// ExtendedCertificatesAndCertificates
	[  32] =   ASN1_OP_MATCH_JUMP_OR_SKIP,
	[  33] =   _tagn(CONT, CONS,  0),
	[  34] =   _jump_target(72),		// --> ExtendedCertificatesAndCertificates
	// Certificates
	[  35] =   ASN1_OP_COND_MATCH_JUMP_OR_SKIP,
	[  36] =   _tagn(CONT, CONS,  2),
	[  37] =   _jump_target(80),		// --> Certificates
	[  38] =   ASN1_OP_ACT,
	[  39] =   _action(ACT_pkcs7_note_certificate_list),
	// CertificateRevocationLists
	[  40] =   ASN1_OP_MATCH_JUMP_OR_SKIP,
	[  41] =   _tagn(CONT, CONS,  1),
	[  42] =   _jump_target(85),		// --> CertificateRevocationLists
	// CRLSequence
	[  43] =   ASN1_OP_COND_MATCH_JUMP_OR_SKIP,
	[  44] =   _tagn(CONT, CONS,  3),
	[  45] =   _jump_target(91),		// --> CRLSequence
	// SignerInfos
	[  46] =   ASN1_OP_MATCH_JUMP_OR_SKIP,		// siSet
	[  47] =   _tag(UNIV, CONS, SET),
	[  48] =   _jump_target(97),
	[  49] =   ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// siSequence
	[  50] =   _tag(UNIV, CONS, SEQ),
	[  51] =   _jump_target(103),
	[  52] =   ASN1_OP_COND_FAIL,
	[  53] =  ASN1_OP_END_SEQ,
	[  54] = ASN1_OP_END_SEQ,
	[  55] = ASN1_OP_RETURN,

	// DigestAlgorithmIdentifier
	[  56] =  ASN1_OP_MATCH_JUMP,
	[  57] =  _tag(UNIV, CONS, SEQ),
	[  58] =  _jump_target(109),		// --> DigestAlgorithmIdentifier
	[  59] = ASN1_OP_END_SET_OF,
	[  60] = _jump_target(56),
	[  61] = ASN1_OP_RETURN,

	// DigestAlgorithmIdentifier
	[  62] =  ASN1_OP_MATCH_JUMP,
	[  63] =  _tag(UNIV, CONS, SEQ),
	[  64] =  _jump_target(109),		// --> DigestAlgorithmIdentifier
	[  65] = ASN1_OP_END_SEQ_OF,
	[  66] = _jump_target(62),
	[  67] = ASN1_OP_RETURN,

	// Data
	[  68] =  ASN1_OP_MATCH_ANY_ACT,
	[  69] =  _action(ACT_pkcs7_note_data),
	[  70] = ASN1_OP_END_SEQ,
	[  71] = ASN1_OP_RETURN,

	// ExtendedCertificateOrCertificate
	// Certificate
	[  72] =  ASN1_OP_MATCH_ANY_ACT,
	[  73] =  _action(ACT_pkcs7_extract_cert),
	// ExtendedCertificate
	// Certificate
	[  74] =  ASN1_OP_COND_MATCH_ANY_ACT,
	[  75] =  _action(ACT_pkcs7_extract_cert),
	[  76] =  ASN1_OP_COND_FAIL,
	[  77] = ASN1_OP_END_SET_OF,
	[  78] = _jump_target(72),
	[  79] = ASN1_OP_RETURN,

	// Certificate
	[  80] =  ASN1_OP_MATCH_ANY_ACT,
	[  81] =  _action(ACT_pkcs7_extract_cert),
	[  82] = ASN1_OP_END_SEQ_OF,
	[  83] = _jump_target(80),
	[  84] = ASN1_OP_RETURN,

	// CertificateList
	[  85] =  ASN1_OP_MATCH_JUMP,
	[  86] =  _tag(UNIV, CONS, SEQ),
	[  87] =  _jump_target(115),		// --> CertificateList
	[  88] = ASN1_OP_END_SET_OF,
	[  89] = _jump_target(85),
	[  90] = ASN1_OP_RETURN,

	// CertificateList
	[  91] =  ASN1_OP_MATCH_JUMP,
	[  92] =  _tag(UNIV, CONS, SEQ),
	[  93] =  _jump_target(115),		// --> CertificateList
	[  94] = ASN1_OP_END_SEQ_OF,
	[  95] = _jump_target(91),
	[  96] = ASN1_OP_RETURN,

	// SignerInfo
	[  97] =  ASN1_OP_MATCH_JUMP,
	[  98] =  _tag(UNIV, CONS, SEQ),
	[  99] =  _jump_target(120),		// --> SignerInfo
	[ 100] = ASN1_OP_END_SET_OF,
	[ 101] = _jump_target(97),
	[ 102] = ASN1_OP_RETURN,

	// SignerInfo
	[ 103] =  ASN1_OP_MATCH_JUMP,
	[ 104] =  _tag(UNIV, CONS, SEQ),
	[ 105] =  _jump_target(120),		// --> SignerInfo
	[ 106] = ASN1_OP_END_SEQ_OF,
	[ 107] = _jump_target(103),
	[ 108] = ASN1_OP_RETURN,

	[ 109] =  ASN1_OP_MATCH_ACT,		// algorithm
	[ 110] =  _tag(UNIV, PRIM, OID),
	[ 111] =  _action(ACT_pkcs7_note_OID),
	[ 112] =  ASN1_OP_MATCH_ANY,		// parameters
	[ 113] = ASN1_OP_END_SEQ,
	[ 114] = ASN1_OP_RETURN,

	// Certificate
	[ 115] =  ASN1_OP_MATCH_ANY_ACT,
	[ 116] =  _action(ACT_pkcs7_extract_cert),
	[ 117] = ASN1_OP_END_SEQ_OF,
	[ 118] = _jump_target(115),
	[ 119] = ASN1_OP_RETURN,

	[ 120] =  ASN1_OP_MATCH,		// version
	[ 121] =  _tag(UNIV, PRIM, INT),
	// IssuerAndSerialNumber
	[ 122] =  ASN1_OP_MATCH,
	[ 123] =  _tag(UNIV, CONS, SEQ),
	// Name
	[ 124] =   ASN1_OP_MATCH,
	[ 125] =   _tag(UNIV, CONS, SEQ),
	// RelativeDistinguishedName
	[ 126] =    ASN1_OP_MATCH,
	[ 127] =    _tag(UNIV, CONS, SET),
	// AttributeValueAssertion
	[ 128] =     ASN1_OP_MATCH,
	[ 129] =     _tag(UNIV, CONS, SEQ),
	[ 130] =      ASN1_OP_MATCH_ACT,		// attributeType
	[ 131] =      _tag(UNIV, PRIM, OID),
	[ 132] =      _action(ACT_pkcs7_note_OID),
	[ 133] =      ASN1_OP_MATCH_ANY,		// attributeValue
	[ 134] =     ASN1_OP_END_SEQ,
	[ 135] =    ASN1_OP_END_SET_OF,
	[ 136] =    _jump_target(128),
	[ 137] =   ASN1_OP_END_SEQ_OF,
	[ 138] =   _jump_target(126),
	[ 139] =   ASN1_OP_ACT,
	[ 140] =   _action(ACT_pkcs7_note_issuer),
	// CertificateSerialNumber
	[ 141] =   ASN1_OP_MATCH,
	[ 142] =   _tag(UNIV, PRIM, INT),
	[ 143] =   ASN1_OP_ACT,
	[ 144] =   _action(ACT_pkcs7_note_serial),
	[ 145] =  ASN1_OP_END_SEQ,
	// DigestAlgorithmIdentifier
	[ 146] =  ASN1_OP_MATCH_JUMP,
	[ 147] =  _tag(UNIV, CONS, SEQ),
	[ 148] =  _jump_target(109),		// --> DigestAlgorithmIdentifier
	[ 149] =  ASN1_OP_ACT,
	[ 150] =  _action(ACT_pkcs7_note_digest_algo),
	// SetOfAuthenticatedAttribute
	[ 151] =  ASN1_OP_MATCH_JUMP_OR_SKIP,
	[ 152] =  _tagn(CONT, CONS,  0),
	[ 153] =  _jump_target(179),		// --> SetOfAuthenticatedAttribute
	[ 154] =  ASN1_OP_ACT,
	[ 155] =  _action(ACT_pkcs7_note_set_of_authattrs),
	[ 156] =  ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// aaSequence
	[ 157] =  _tagn(CONT, CONS,  2),
	[ 158] =  _jump_target(185),
	// DigestEncryptionAlgorithmIdentifier
	[ 159] =  ASN1_OP_MATCH,
	[ 160] =  _tag(UNIV, CONS, SEQ),
	[ 161] =   ASN1_OP_MATCH_ACT,		// algorithm
	[ 162] =   _tag(UNIV, PRIM, OID),
	[ 163] =   _action(ACT_pkcs7_note_OID),
	[ 164] =   ASN1_OP_MATCH_ANY,		// parameters
	[ 165] =  ASN1_OP_END_SEQ,
	[ 166] =  ASN1_OP_ACT,
	[ 167] =  _action(ACT_pkcs7_note_pkey_algo),
	// EncryptedDigest
	[ 168] =  ASN1_OP_MATCH_ACT,
	[ 169] =  _tag(UNIV, PRIM, OTS),
	[ 170] =  _action(ACT_pkcs7_note_signature),
	[ 171] =  ASN1_OP_MATCH_JUMP_OR_SKIP,		// uaSet
	[ 172] =  _tagn(CONT, CONS,  1),
	[ 173] =  _jump_target(194),
	[ 174] =  ASN1_OP_COND_MATCH_JUMP_OR_SKIP,		// uaSequence
	[ 175] =  _tagn(CONT, CONS,  3),
	[ 176] =  _jump_target(200),
	[ 177] = ASN1_OP_END_SEQ,
	[ 178] = ASN1_OP_RETURN,

	// AuthenticatedAttribute
	[ 179] =  ASN1_OP_MATCH_JUMP,
	[ 180] =  _tag(UNIV, CONS, SEQ),
	[ 181] =  _jump_target(206),		// --> AuthenticatedAttribute
	[ 182] = ASN1_OP_END_SET_OF,
	[ 183] = _jump_target(179),
	[ 184] = ASN1_OP_RETURN,

	[ 185] =  ASN1_OP_MATCH,		// aaSequence
	[ 186] =  _tag(UNIV, CONS, SEQ),
	// AuthenticatedAttribute
	[ 187] =   ASN1_OP_MATCH_JUMP,
	[ 188] =   _tag(UNIV, CONS, SEQ),
	[ 189] =   _jump_target(206),		// --> AuthenticatedAttribute
	[ 190] =  ASN1_OP_END_SEQ_OF,
	[ 191] =  _jump_target(187),
	[ 192] = ASN1_OP_END_SEQ,
	[ 193] = ASN1_OP_RETURN,

	// UnauthenticatedAttribute
	[ 194] =  ASN1_OP_MATCH_JUMP,
	[ 195] =  _tag(UNIV, CONS, SEQ),
	[ 196] =  _jump_target(217),		// --> UnauthenticatedAttribute
	[ 197] = ASN1_OP_END_SET_OF,
	[ 198] = _jump_target(194),
	[ 199] = ASN1_OP_RETURN,

	// UnauthenticatedAttribute
	[ 200] =  ASN1_OP_MATCH_JUMP,
	[ 201] =  _tag(UNIV, CONS, SEQ),
	[ 202] =  _jump_target(217),		// --> UnauthenticatedAttribute
	[ 203] = ASN1_OP_END_SEQ_OF,
	[ 204] = _jump_target(200),
	[ 205] = ASN1_OP_RETURN,

	[ 206] =  ASN1_OP_MATCH_ACT,		// type
	[ 207] =  _tag(UNIV, PRIM, OID),
	[ 208] =  _action(ACT_pkcs7_note_OID),
	[ 209] =  ASN1_OP_MATCH,		// values
	[ 210] =  _tag(UNIV, CONS, SET),
	[ 211] =   ASN1_OP_MATCH_ANY_ACT,
	[ 212] =   _action(ACT_pkcs7_note_authenticated_attr),
	[ 213] =  ASN1_OP_END_SET_OF,
	[ 214] =  _jump_target(211),
	[ 215] = ASN1_OP_END_SEQ,
	[ 216] = ASN1_OP_RETURN,

	[ 217] =  ASN1_OP_MATCH_ACT,		// type
	[ 218] =  _tag(UNIV, PRIM, OID),
	[ 219] =  _action(ACT_pkcs7_note_OID),
	[ 220] =  ASN1_OP_MATCH,		// values
	[ 221] =  _tag(UNIV, CONS, SET),
	[ 222] =   ASN1_OP_MATCH_ANY,
	[ 223] =  ASN1_OP_END_SET_OF,
	[ 224] =  _jump_target(222),
	[ 225] = ASN1_OP_END_SEQ,
	[ 226] = ASN1_OP_RETURN,
};

const struct asn1_decoder pkcs7_decoder = {
	.machine = pkcs7_machine,
	.machlen = sizeof(pkcs7_machine),
	.actions = pkcs7_action_table,
};
